package com.yunzhi.marketing.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.yunzhi.marketing.base.ResponseBean;
import com.yunzhi.marketing.dto.StatisticsDTO;
import com.yunzhi.marketing.po.CustomerRankListVO;
import com.yunzhi.marketing.service.ChannelCustomerStatisticsService;
import com.yunzhi.marketing.xlk.entity.BuildingChannel;
import com.yunzhi.marketing.xlk.mapper.BuildingChannelMapper;
import com.yunzhi.marketing.xlk.mapper.ChannelCustomerMapper;
import org.ietf.jgss.ChannelBinding;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class ChannelCustomerStatisticsServiceImpl implements ChannelCustomerStatisticsService {

    @Autowired
    private BuildingChannelMapper buildingChannelMapper;

    @Autowired
    private ChannelCustomerMapper channelCustomerMapper;

    @Override
    public ResponseBean getRanklist(StatisticsDTO statisticsDTo) {
        LambdaQueryWrapper<BuildingChannel> lambdaQueryWrapper = new LambdaQueryWrapper<>();
        lambdaQueryWrapper.eq(BuildingChannel::getBuildingId,statisticsDTo.getBuildingId());
        BuildingChannel buildingChannel = buildingChannelMapper.selectOne(lambdaQueryWrapper);

        if (null == buildingChannel) {
            return ResponseBean.error("此楼盘未绑定渠道商", ResponseBean.ERROR_UNAVAILABLE);
        }
        statisticsDTo.setChannelId(buildingChannel.getChannelId());
        List<CustomerRankListVO> list = channelCustomerMapper.getRanklist(statisticsDTo);
        return ResponseBean.success(list);
    }
}
